Index: tmp/org.txm.edition.rcp/src/org/txm/edition/rcp/editors/SynopticEditionEditor.java
===================================================================
--- tmp/org.txm.edition.rcp/src/org/txm/edition/rcp/editors/SynopticEditionEditor.java	(revision 3060)
+++ tmp/org.txm.edition.rcp/src/org/txm/edition/rcp/editors/SynopticEditionEditor.java	(revision 3061)
@@ -75,6 +75,7 @@
 import org.txm.edition.rcp.messages.EditionUIMessages;
 import org.txm.objects.Edition;
 import org.txm.objects.Page;
+import org.txm.objects.Project;
 import org.txm.objects.Text;
 import org.txm.rcp.IImageKeys;
 import org.txm.rcp.editors.IEditionEditor;
@@ -126,6 +127,8 @@
 	// private Label text_label;
 	private TXMAutoCompleteField identifiantComboAutoCompleteField;
 	
+	private SearchEditionToolbar set;
+	
 	// TODO finish editor conversion
 	@Override
 	public Text getResult() {
@@ -135,6 +138,10 @@
 		return text;
 	}
 	
+	public SearchEditionToolbar getSearchEditionToolbar() {
+		return set;
+	}
+	
 	/**
 	 * Instantiates a new txm browser.
 	 */
@@ -384,6 +391,18 @@
 		this.removeComputeButton();
 		
 		editionsArea = getResultArea();
+		editionsArea.addKeyListener(new KeyListener() {
+			
+			@Override
+			public void keyReleased(KeyEvent e) {
+				if (e.keyCode == 102 && (e.stateMask & SWT.CTRL) != 0) {
+					getSearchEditionToolbar().openSearch(getTextSelection());
+				}
+			}
+			
+			@Override
+			public void keyPressed(KeyEvent e) {}
+		});
 		
 		lowerControlsArea = getBottomToolbar().installGLComposite(EditionUIMessages.controls, 15, false);
 		lowerControlsArea.setLayoutData(new GridData(GridData.FILL, GridData.FILL, true, false));
@@ -395,12 +414,17 @@
 		
 		// supplementaryButtonToolbar = new TXMEditorToolBar(this, getTopToolbarContainer(), annotationWidgetsArea, SWT.NONE, "annotation urs");
 		
+		set = new SearchEditionToolbar();
+		Project project = this.getResult().getProject();
+		MainCorpus mcorpus = (MainCorpus) project.getCorpusBuild(project.getName().toUpperCase(), MainCorpus.class);
+		set.init(lowerControlsArea, mcorpus, this);
+		
 		// Edition names label
-		editionsChooser = new Button(lowerControlsArea, SWT.PUSH);
-		editionsChooser.setText(StringUtils.join(editionNames, " | ")); //$NON-NLS-1$
 		
+		
 		if (mainCorpus.getProject().getBuiltEditionNames().size() > 1) {
-			
+			editionsChooser = new Button(lowerControlsArea, SWT.PUSH);
+			editionsChooser.setText(StringUtils.join(editionNames, " | ")); //$NON-NLS-1$
 			editionsChooser.addSelectionListener(new SelectionListener() {
 				
 				@Override
@@ -436,9 +460,6 @@
 				public void widgetDefaultSelected(SelectionEvent e) {}
 			});
 		}
-		else {
-			editionsChooser.setEnabled(false);
-		}
 		
 		// Navigation buttons
 		GLComposite pageNavigationComposite = new GLComposite(lowerControlsArea, SWT.NONE, EditionUIMessages.pageButtons);
@@ -450,7 +471,7 @@
 		page_label = new Label(pageNavigationComposite, SWT.NONE);
 		Button next = new Button(pageNavigationComposite, SWT.FLAT | SWT.PUSH);
 		Button last = new Button(pageNavigationComposite, SWT.FLAT | SWT.PUSH);
-		pageNavigationComposite.setLayoutData(new GridData(GridData.CENTER, GridData.FILL, true, false));
+		pageNavigationComposite.setLayoutData(new GridData(GridData.CENTER, GridData.CENTER, true, false));
 		
 		GLComposite textNavigationComposite = new GLComposite(lowerControlsArea, SWT.NONE, EditionUIMessages.textButtons);
 		textNavigationComposite.getLayout().numColumns = 7;
@@ -461,7 +482,7 @@
 		KeyStroke keys = KeyStroke.getInstance(SWT.CONTROL, SWT.SPACE);
 		try {
 			String[] text_ids = corpus.getCorpusTextIdsList();
-			GridData gdata = new GridData(GridData.CENTER, GridData.FILL, true, false);
+			GridData gdata = new GridData(GridData.CENTER, GridData.CENTER, true, false);
 			gdata.minimumWidth = 1;
 			for (String text_id : text_ids) {
 				double s = text_id.length() * 7;
@@ -489,10 +510,10 @@
 		// text_label = new Label(textNavigationComposite, SWT.NONE);
 		Button nextText = new Button(textNavigationComposite, SWT.FLAT | SWT.PUSH);
 		Button lastText = new Button(textNavigationComposite, SWT.FLAT | SWT.PUSH);
-		textNavigationComposite.setLayoutData(new GridData(GridData.CENTER, GridData.FILL, false, false));
+		textNavigationComposite.setLayoutData(new GridData(GridData.CENTER, GridData.CENTER, false, false));
 		// Layouts data
 		
-		editionsChooser.setLayoutData(new GridData(GridData.BEGINNING, GridData.CENTER, false, false));
+		if (editionsChooser != null) editionsChooser.setLayoutData(new GridData(GridData.BEGINNING, GridData.CENTER, false, false));
 		
 		// GridData buttonGridData = new GridData(GridData.END,GridData.CENTER, true, false);
 		// buttonGridData.widthHint = 30;
Index: tmp/org.txm.core/src/java/org/txm/importer/xtz/ImportStep.java
===================================================================
--- tmp/org.txm.core/src/java/org/txm/importer/xtz/ImportStep.java	(revision 3060)
+++ tmp/org.txm.core/src/java/org/txm/importer/xtz/ImportStep.java	(revision 3061)
@@ -3,6 +3,8 @@
 import java.io.File;
 import java.util.HashMap;
 
+import org.txm.objects.Project;
+
 /**
  * One of the step of an import module
  * 
@@ -10,18 +12,26 @@
  *
  */
 public abstract class ImportStep {
-
+	
 	protected File inputDirectory, outputDirectory;
+	
 	protected ImportModule module;
 	
-	protected HashMap<String, Object> stepProperties = new HashMap<String, Object>();
+	protected Project project;
+	
+	protected HashMap<String, Object> stepProperties = new HashMap<>();
+	
 	protected boolean isSuccessFul = false;
+	
 	protected String reason = "not set.";
+	
 	protected boolean stopAtFirstError = true;
+	
 	protected boolean debug = true;
 	
 	public ImportStep(ImportModule module) {
 		this.module = module;
+		this.project = module.getProject();
 		debug = module.debug;
 	}
 	
Index: tmp/org.txm.core/src/java/org/txm/importer/ImportFileManager.java
===================================================================
--- tmp/org.txm.core/src/java/org/txm/importer/ImportFileManager.java	(revision 3060)
+++ tmp/org.txm.core/src/java/org/txm/importer/ImportFileManager.java	(revision 3061)
@@ -94,7 +94,7 @@
 			
 			LinkedHashMap<String, String> sectionParameters = new LinkedHashMap<>();
 			sections.put(name, sectionParameters);
-			NodeList parameterList = doc.getElementsByTagName("parameter");
+			NodeList parameterList = section.getElementsByTagName("parameter");
 			for (int j = 0; j < parameterList.getLength(); j++) {
 				Element parameter = (Element) parameterList.item(j);
 				String name2 = parameter.getAttribute("name");
Index: tmp/org.txm.core/src/java/org/txm/importer/ImportPreferencesManager.java
===================================================================
--- tmp/org.txm.core/src/java/org/txm/importer/ImportPreferencesManager.java	(revision 0)
+++ tmp/org.txm.core/src/java/org/txm/importer/ImportPreferencesManager.java	(revision 3061)
@@ -0,0 +1,160 @@
+package org.txm.importer;
+
+import java.io.File;
+import java.io.FileNotFoundException;
+import java.io.IOException;
+import java.io.UnsupportedEncodingException;
+import java.util.LinkedHashMap;
+
+import javax.xml.parsers.ParserConfigurationException;
+
+import org.eclipse.core.runtime.preferences.IEclipsePreferences;
+import org.osgi.service.prefs.BackingStoreException;
+import org.osgi.service.prefs.Preferences;
+import org.txm.objects.Project;
+import org.txm.utils.logger.Log;
+import org.txm.utils.xml.DomUtils;
+import org.w3c.dom.Document;
+import org.w3c.dom.Element;
+import org.w3c.dom.NodeList;
+import org.xml.sax.SAXException;
+
+/**
+ * Read and save a import parameter file
+ * 
+ * The file is read to fill the ImportFormEditor > CorpusPage widgets
+ * 
+ * @author mdecorde
+ *
+ */
+public class ImportPreferencesManager {
+	
+	/**
+	 * one map per import section
+	 */
+	LinkedHashMap<String, LinkedHashMap<String, String>> sections = new LinkedHashMap<>();
+	
+	private Project project;
+	
+	public ImportPreferencesManager(Project project) {
+		this.project = project;
+	}
+	
+	public LinkedHashMap<String, LinkedHashMap<String, String>> getSections() {
+		return sections;
+	}
+	
+	public LinkedHashMap<String, String> getSection(String name) {
+		if (name == null) return null;
+		return sections.get(name);
+	}
+	
+	public String load() throws BackingStoreException {
+		String version = project.getCorpusVersion();
+		if ("0.8.0".equals(version)) {
+			loadFrom080();
+		}
+		else if ("0.8.2".equals(version)) {
+			genericLoad();
+		}
+		else {
+			return "Wrong import parameter file version: " + project + ": " + version;
+		}
+		return "";
+	}
+	
+	private void loadFrom080() {
+		// TODO Auto-generated method stub
+		
+	}
+	
+	/**
+	 * simple reading of all section parameters are stored in a section element with parameter elements (@key + text)
+	 * 
+	 * @throws BackingStoreException
+	 */
+	private void genericLoad() throws BackingStoreException {
+		sections.clear();
+		
+		Preferences sectionList = project.getPreferencesScope().getNode("import").node("sections");
+		String[] sectionNames = sectionList.childrenNames();
+		for (int i = 0; i < sectionNames.length; i++) {
+			Preferences section = sectionList.node(sectionNames[i]);
+			String name = section.name();
+			if (name == null || name.length() == 0) {
+				Log.warning("Load import 0.8.2 parameters: section with no name");
+				continue;
+			}
+			if (sections.containsKey(name)) {
+				Log.warning("Load import 0.8.2 parameters: duplicated section with name:" + name);
+				continue;
+			}
+			
+			LinkedHashMap<String, String> sectionParameters = new LinkedHashMap<>();
+			sections.put(name, sectionParameters);
+			for (String name2 : section.keys()) {
+				String parameter = section.get(name2, "");
+				
+				if (sectionParameters.containsKey(name2)) {
+					Log.warning("Load import 0.8.2 parameters: duplicated parameter with name:" + name2 + " in section: " + name);
+					continue;
+				}
+				
+				sectionParameters.put(name2, parameter);
+			}
+		}
+	}
+	
+	public String save() throws BackingStoreException {
+		String version = project.getCorpusVersion();
+		if ("0.8.0".equals(version)) {
+			saveFrom080();
+		}
+		else if ("0.8.2".equals(version)) {
+			genericSave();
+		}
+		else {
+			return "Wrong import parameter file version: " + project + ": " + version;
+		}
+		return "";
+	}
+	
+	private void genericSave() throws BackingStoreException {
+		IEclipsePreferences importNode = project.getPreferencesScope().getNode("import");
+		Preferences sectionList = importNode.node("sections");
+		
+		// store previous values
+		if (importNode.nodeExists("sections-previous")) {
+			importNode.node("sections-previous").removeNode(); // clear previous values
+		}
+		Preferences oldSectionList = importNode.node("sections-previous"); // create/get the node
+		oldSectionList.removeNode();
+		for (String section : sectionList.childrenNames()) {
+			Preferences sectionPref = sectionList.node(section);
+			Preferences sectionPref2 = oldSectionList.node(section);
+			for (String key : sectionPref.keys()) {
+				sectionPref2.put(key, sectionPref.get(key, ""));
+			}
+		}
+		
+		// clear the sections list
+		sectionList.clear();
+		for (String section : sectionList.childrenNames()) {
+			sectionList.node(section).removeNode();
+		}
+		
+		// recreate sections
+		for (String section : this.sections.keySet()) {
+			Preferences n = sectionList.node(section);
+			LinkedHashMap<String, String> prefs = this.sections.get(section);
+			for (String key : prefs.keySet()) {
+				n.put(key, prefs.get(key));
+			}
+		}
+	}
+	
+	private void saveFrom080() {
+		// TODO Auto-generated method stub
+		
+	}
+}

Index: tmp/org.txm.core/src/java/org/txm/scripts/importer/ReadImportParameters.groovy
===================================================================
--- tmp/org.txm.core/src/java/org/txm/scripts/importer/ReadImportParameters.groovy	(revision 3060)
+++ tmp/org.txm.core/src/java/org/txm/scripts/importer/ReadImportParameters.groovy	(revision 3061)
@@ -31,14 +31,11 @@
 	String description;
 	
 	boolean debug;
-
-	public ReadImportParameters()
-	{
-
+	
+	public ReadImportParameters() {
 	}
-
-	public boolean read(File infile)
-	{
+	
+	public boolean read(File infile) {
 		try {
 			def url = infile.toURI().toURL();
 			def inputData = url.openStream();
@@ -53,11 +50,9 @@
 		}catch (IOException ex) {
 			System.out.println("IOException while parsing ");
 		}
-		
 	}
-
-	public boolean read(def parser)
-	{
+	
+	public boolean read(def parser) {
 		boolean startAlignInfos = false;
 		boolean startEditions = false;
 		boolean startMetadatas = false;
@@ -65,42 +60,34 @@
 		boolean startSAttributes = false;
 		boolean startTokenizer = false;
 		
-		for (int event = parser.next(); event != XMLStreamConstants.END_DOCUMENT; event = parser.next())
-		{
+		for (int event = parser.next(); event != XMLStreamConstants.END_DOCUMENT; event = parser.next()) {
 			switch (event) {
-
+				
 				case XMLStreamConstants.END_ELEMENT:
 					String localname = parser.getLocalName();
-					if(localname == "linkGrp")
-					{
+					if(localname == "linkGrp") {
 						startAlignInfos = false;
 					}
-					else if(localname == "metadatas")
-					{
+					else if(localname == "metadatas") {
 						startMetadatas = false;
 					}
-					else if(localname == "editions")
-					{
+					else if(localname == "editions") {
 						startEditions = false;
 					}
-					else if(localname == "pattributes")
-					{
+					else if(localname == "pattributes") {
 						startPAttributes = false;
 					}
-					else if(localname == "sattributes")
-					{
+					else if(localname == "sattributes") {
 						startSAttributes = false;
 					}
-					else if(localname == "tokenizer")
-					{
+					else if(localname == "tokenizer") {
 						startSAttributes = false;
 					}
 					break;
-
+				
 				case XMLStreamConstants.START_ELEMENT:
 					String localname = parser.getLocalName();
-					if (localname == "import")
-					{
+					if (localname == "import") {
 						basename = parser.getAttributeValue(null, "name");
 						encoding = parser.getAttributeValue(null, "encoding");
 						language = parser.getAttributeValue(null, "lang");
@@ -112,12 +99,10 @@
 						
 						boolean debug;
 					}
-					else if(localname == "editions")
-					{
+					else if(localname == "editions") {
 						startEditions = true;
 					}
-					else if(localname == "edition")
-					{
+					else if(localname == "edition") {
 						String corpus = parser.getAttributeValue(null, "corpus")
 						if(!editions.containsKey(corpus))
 							editions.put(corpus, []);
@@ -133,52 +118,52 @@
 						startMetadatas = true;
 					}
 					else if (localname == "metadata" && startMetadatas) {
-						metadatas.put(parser.getAttributeValue(null, "id"), 
-							["id":parser.getAttributeValue(null, "id"),
-							"shortname":parser.getAttributeValue(null, "shortname"),
-							"longname":parser.getAttributeValue(null, "longname"),
-							"type":parser.getAttributeValue(null, "type"),
-							"selection":parser.getAttributeValue(null, "selection"),
-							"partition":parser.getAttributeValue(null, "partition"),
-							"display":parser.getAttributeValue(null, "display"),])
+						metadatas.put(parser.getAttributeValue(null, "id"),
+								["id":parser.getAttributeValue(null, "id"),
+									"shortname":parser.getAttributeValue(null, "shortname"),
+									"longname":parser.getAttributeValue(null, "longname"),
+									"type":parser.getAttributeValue(null, "type"),
+									"selection":parser.getAttributeValue(null, "selection"),
+									"partition":parser.getAttributeValue(null, "partition"),
+									"display":parser.getAttributeValue(null, "display"),])
 					}
 					else if (localname == "pattributes") {
 						startPAttributes = true;
 					} else if(localname == "pattribute" && startPAttributes) {
-						pattributes.put(parser.getAttributeValue(null, "id"), 
-							["id":parser.getAttributeValue(null, "id"),
-							"shortname":parser.getAttributeValue(null, "shortname"),
-							"longname":parser.getAttributeValue(null, "longname"),
-							"type":parser.getAttributeValue(null, "type"),
-							"renderer":parser.getAttributeValue(null, "renderer"),
-							"tooltip":parser.getAttributeValue(null, "tooltip"),
-							"display":parser.getAttributeValue(null, "display"),
-							"min":parser.getAttributeValue(null, "min"),
-							"max":parser.getAttributeValue(null, "max"),
-							"inputFormat":parser.getAttributeValue(null, "inputFormat"),
-							"outputFormat":parser.getAttributeValue(null, "outputFormat"),
-							"position":parser.getAttributeValue(null, "position"),
-							"sortBy":parser.getAttributeValue(null, "sortBy")])
+						pattributes.put(parser.getAttributeValue(null, "id"),
+								["id":parser.getAttributeValue(null, "id"),
+									"shortname":parser.getAttributeValue(null, "shortname"),
+									"longname":parser.getAttributeValue(null, "longname"),
+									"type":parser.getAttributeValue(null, "type"),
+									"renderer":parser.getAttributeValue(null, "renderer"),
+									"tooltip":parser.getAttributeValue(null, "tooltip"),
+									"display":parser.getAttributeValue(null, "display"),
+									"min":parser.getAttributeValue(null, "min"),
+									"max":parser.getAttributeValue(null, "max"),
+									"inputFormat":parser.getAttributeValue(null, "inputFormat"),
+									"outputFormat":parser.getAttributeValue(null, "outputFormat"),
+									"position":parser.getAttributeValue(null, "position"),
+									"sortBy":parser.getAttributeValue(null, "sortBy")])
 					}
 					else if (localname == "sattributes") {
 						startSAttributes = true;
 					}
 					else if (localname == "sattribute" && startSAttributes) {
-						sattributes.put(parser.getAttributeValue(null, "id"), 
-							["id":parser.getAttributeValue(null, "id"),
-							"shortname":parser.getAttributeValue(null, "shortname"),
-							"longname":parser.getAttributeValue(null, "longname"),
-							"type":parser.getAttributeValue(null, "type"),
-							"renderer":parser.getAttributeValue(null, "renderer"),
-							"tooltip":parser.getAttributeValue(null, "tooltip"),
-							"pattern":parser.getAttributeValue(null, "renderer"),
-							"import":parser.getAttributeValue(null, "import"),
-							"min":parser.getAttributeValue(null, "min"),
-							"max":parser.getAttributeValue(null, "max"),
-							"mandatory":parser.getAttributeValue(null, "mandatory"),
-							"order":parser.getAttributeValue(null, "order"),
-							"inputFormat":parser.getAttributeValue(null, "inputFormat"),
-							"outputFormat":parser.getAttributeValue(null, "outputFormat"),])
+						sattributes.put(parser.getAttributeValue(null, "id"),
+								["id":parser.getAttributeValue(null, "id"),
+									"shortname":parser.getAttributeValue(null, "shortname"),
+									"longname":parser.getAttributeValue(null, "longname"),
+									"type":parser.getAttributeValue(null, "type"),
+									"renderer":parser.getAttributeValue(null, "renderer"),
+									"tooltip":parser.getAttributeValue(null, "tooltip"),
+									"pattern":parser.getAttributeValue(null, "renderer"),
+									"import":parser.getAttributeValue(null, "import"),
+									"min":parser.getAttributeValue(null, "min"),
+									"max":parser.getAttributeValue(null, "max"),
+									"mandatory":parser.getAttributeValue(null, "mandatory"),
+									"order":parser.getAttributeValue(null, "order"),
+									"inputFormat":parser.getAttributeValue(null, "inputFormat"),
+									"outputFormat":parser.getAttributeValue(null, "outputFormat"),])
 					} else if (localname == "link" && startAlignInfos) {
 						String target = parser.getAttributeValue(null, "target");
 						String struct = parser.getAttributeValue(null, "alignElement");
@@ -191,10 +176,10 @@
 								i--
 							}
 						}
-
+						
 						if (level == null)
 							level = "1";
-
+						
 						if (corpora.size() == 0) {
 							println "no corpus aligned: "+parser.getLocation()
 							return false;
@@ -214,32 +199,26 @@
 			}
 		}
 	}
-
-	public Set<String> getAlignements()
-	{
+	
+	public Set<String> getAlignements() {
 		return links.keySet();
 	}
-
-	public ArrayList<String> getTargets(String alignement)
-	{
+	
+	public ArrayList<String> getTargets(String alignement) {
 		return links.get(alignement);
 	}
-
-	public String getStructure(String alignement)
-	{
+	
+	public String getStructure(String alignement) {
 		return structs.get(alignement);
 	}
-
-	public int getLevel(String alignement)
-	{
+	
+	public int getLevel(String alignement) {
 		return levels.get(alignement);
 	}
-
-	public void dump()
-	{
+	
+	public void dump() {
 		println "LINKS"
-		for(String link : links.keySet())
-		{
+		for(String link : links.keySet()) {
 			println link
 			println " corpus: "+links.get(link)
 			println " struct: "+structs.get(link)
@@ -268,9 +247,8 @@
 		println " description $description"
 		println "DEBUG: $debug"
 	}
-
-	public static void main(String[] args)
-	{
+	
+	public static void main(String[] args) {
 		String userhome = System.getProperty("user.home");
 		File alignfile = new File(userhome, "xml/xmltxmpara/align.xml")
 		ReadImportParameters parameters = new ReadImportParameters();
Index: tmp/org.txm.core/src/java/org/txm/core/engines/EnginesManager.java
===================================================================
--- tmp/org.txm.core/src/java/org/txm/core/engines/EnginesManager.java	(revision 3060)
+++ tmp/org.txm.core/src/java/org/txm/core/engines/EnginesManager.java	(revision 3061)
@@ -19,26 +19,26 @@
  * @author sjacquot
  *
  */
-public abstract class EnginesManager<T extends Engine> extends HashMap<String, T>{
-
+public abstract class EnginesManager<T extends Engine> extends HashMap<String, T> {
+	
 	private static final long serialVersionUID = 9186978207738860351L;
-
+	
 	public static final String ENGINES_MANAGER_EXTENSION_POINT_ID = EnginesManager.class.getName();
-
+	
 	/**
 	 * Current engine.
 	 */
 	protected T currentEngine = null;
-
 	
 	
+	
 	/**
 	 * Finds out the engines that matches this manager engines extension point.
 	 * 
 	 * @return
 	 */
 	public abstract boolean fetchEngines();
-
+	
 	/**
 	 * Creates and initializes the engines from contributions with the specified extension point id.
 	 * 
@@ -46,33 +46,35 @@
 	 * @return true if at least one engine has been created otherwise false
 	 */
 	protected boolean fetchEngines(String engineExtensionPointId) {
-
+		
 		IConfigurationElement[] contributions = RegistryFactory.getRegistry().getConfigurationElementsFor(engineExtensionPointId);
-
+		
 		Log.finest(TXMCoreMessages.bind("Looking for {0} engines contributions with extension point id {1}...", this.getEnginesDescription(), engineExtensionPointId)); //$NON-NLS-1$
 		Log.finest(TXMCoreMessages.bind("{0} engine(s) found.", contributions.length)); //$NON-NLS-1$
-
+		
 		for (int i = 0; i < contributions.length; i++) {
 			try {
 				@SuppressWarnings("unchecked")
 				T engine = (T) contributions[i].createExecutableExtension("class"); //$NON-NLS-1$
-
+				
 				Log.fine(TXMCoreMessages.bind("Initializing engine: {0}...", engine));
-
+				
 				if (engine.initialize()) {
 					this.put(engine.getName(), engine);
-				} else {
+				}
+				else {
 					Log.severe("Failed to initialize " + engine.getName() + " engine.");
 				}
-			} catch (Exception e) {
+			}
+			catch (Exception e) {
 				Log.severe("Error: failed to instantiate " + contributions[i].getName() + ".");
 				e.printStackTrace();
 			}
 		}
-
+		
 		return this.size() > 0;
 	}
-
+	
 	/**
 	 * Starts the engines.
 	 * 
@@ -81,30 +83,32 @@
 	 */
 	public boolean startEngines(IProgressMonitor monitor) {
 		for (Engine engine : this.values()) {
-
+			
 			String log = "Starting " + this.getEnginesDescription() + " engine: " + engine.getName() + "...";
 			Log.fine(log);
-
+			
 			if (monitor != null) {
 				monitor.subTask(log);
 			}
-
+			
 			try {
 				engine.start(monitor);
-			} catch (Exception e) {
+			}
+			catch (Exception e) {
 				Log.severe("Error: failed to start engine " + engine.getName() + ".");
 				e.printStackTrace();
 			}
 		}
-
+		
 		if (this.currentEngine == null && this.size() > 0) {
 			this.setCurrentEngine((T) this.values().toArray()[0]);
 		}
 		return true;
 	}
-
+	
+	@Override
 	public String toString() {
-		return getEnginesType()+": "+super.toString();
+		return getEnginesType() + ": " + super.toString();
 	}
 	
 	/**
@@ -115,10 +119,10 @@
 		if (currentEngine == null) {
 			return false;
 		}
-
+		
 		return currentEngine.isRunning();
 	}
-
+	
 	/**
 	 * Stops the engines.
 	 * 
@@ -126,19 +130,20 @@
 	 */
 	public boolean stopEngines() {
 		for (Engine engine : this.values()) {
-
+			
 			Log.fine("Stopping " + this.getEnginesDescription() + " engine: " + engine.getName() + "..."); //$NON-NLS-1$
-
+			
 			try {
 				engine.stop();
-			} catch (Exception e) {
+			}
+			catch (Exception e) {
 				Log.severe("Error: failed to stop engine " + engine.getName() + ".");
 				e.printStackTrace();
 			}
 		}
 		return true;
 	}
-
+	
 	/**
 	 * Restarts the engines.
 	 * 
@@ -158,23 +163,24 @@
 					Log.fine("Starting " + this.getEnginesDescription() + " engine: " + engine.getName() + "..."); //$NON-NLS-1$
 					engine.start(new LogMonitor());
 				}
-			} catch (Exception e) {
+			}
+			catch (Exception e) {
 				Log.severe("Error: failed to stop engine " + engine.getName() + ".");
 				e.printStackTrace();
 			}
 		}
 		return true;
 	}
-
+	
 	/**
 	 * Gets the engine type that this manager supports.
 	 * 
 	 * @return the engine type that this manager supports
 	 */
 	public abstract EngineType getEnginesType();
-
 	
 	
+	
 	/**
 	 * Gets the engine description that this manager supports.
 	 * 
@@ -183,7 +189,7 @@
 	public String getEnginesDescription() {
 		return this.getEnginesType().getDescription();
 	}
-
+	
 	/**
 	 * Gets the available engines.
 	 * 
@@ -192,7 +198,7 @@
 	public HashMap<String, T> getEngines() {
 		return this;
 	}
-
+	
 	/**
 	 * Gets an engine specified by its name.
 	 * 
@@ -211,7 +217,7 @@
 	public T getCurrentEngine() {
 		return this.currentEngine;
 	}
-
+	
 	/**
 	 * Sets the current engine.
 	 * 
@@ -221,7 +227,7 @@
 		Log.finest("Setting current " + this.getEnginesDescription() + " engine to " + engine + ".");
 		this.currentEngine = engine;
 	}
-
+	
 	/**
 	 * Sets the current engine specified by its name.
 	 * 
@@ -230,7 +236,7 @@
 	public void setCurrentEngine(String name) {
 		this.setCurrentEngine(this.getEngine(name));
 	}
-
+	
 	/**
 	 * Gets an installed engine according to its class type.
 	 * 
Index: tmp/org.txm.core/src/java/org/txm/core/preferences/TXMPreferences.java
===================================================================
--- tmp/org.txm.core/src/java/org/txm/core/preferences/TXMPreferences.java	(revision 3060)
+++ tmp/org.txm.core/src/java/org/txm/core/preferences/TXMPreferences.java	(revision 3061)
@@ -117,6 +117,16 @@
 	public static final String QUERY = "query"; //$NON-NLS-1$
 	
 	/**
+	 * Result index.
+	 */
+	public static final String INDEX = "index"; //$NON-NLS-1$
+	
+	/**
+	 * Result sub index.
+	 */
+	public static final String SUB_INDEX = "sub_index"; //$NON-NLS-1$
+	
+	/**
 	 * Structural unit.
 	 */
 	public static final String STRUCTURAL_UNIT = "structural_unit"; //$NON-NLS-1$
Index: tmp/org.txm.core/src/java/org/txm/objects/Match.java
===================================================================
--- tmp/org.txm.core/src/java/org/txm/objects/Match.java	(revision 3060)
+++ tmp/org.txm.core/src/java/org/txm/objects/Match.java	(revision 3061)
@@ -3,21 +3,38 @@
 import java.util.ArrayList;
 import java.util.List;
 
+/**
+ * Abstraction of a match. A Match is defined by its start-end positions.
+ * 
+ * It may have a target position to focus a position
+ * 
+ * TODO manage multiple target positions
+ * TODO manage multiple labeled target positions
+ * TODO store match index (hard to update the match indices ?)
+ * TODO store sub match index (hard to update the submatch indices ?)
+ * 
+ * @author mdecorde
+ *
+ */
 public abstract class Match implements Comparable<Match> {
+	
 	public abstract int getStart();
+	
 	public abstract int getEnd();
+	
 	public abstract int getTarget();
 	
 	public boolean contains(Match m) {
 		return (this.getStart() <= m.getStart() && m.getEnd() <= this.getEnd());
 	}
 	
-	/* (non-Javadoc)
+	/*
+	 * (non-Javadoc)
 	 * @see java.lang.Comparable#compareTo(java.lang.Object)
 	 */
 	@Override
 	public int compareTo(Match m) {
-
+		
 		if (m == null)
 			return -1;
 		if (this.getStart() < m.getStart())
@@ -28,10 +45,10 @@
 			return -1;
 		else
 			return 1;
-
 	}
-
-	/* (non-Javadoc)
+	
+	/*
+	 * (non-Javadoc)
 	 * @see java.lang.Object#toString()
 	 */
 	@Override
@@ -49,19 +66,21 @@
 	}
 	
 	public List<Integer> getRange() {
-		List<Integer> ret = new ArrayList<Integer>(size());
-		for (int i = getStart() ; i <= getEnd(); i++) ret.add(i);
+		List<Integer> ret = new ArrayList<>(size());
+		for (int i = getStart(); i <= getEnd(); i++)
+			ret.add(i);
 		return ret;
 	}
-
+	
 	public abstract void setEnd(int p);
-
+	
 	public abstract void setStart(int p);
 	
 	public abstract void setTarget(int p);
 	
 	/**
 	 * intersect sorted list of Matches
+	 * 
 	 * @param list1
 	 * @param sublist2
 	 * @param strict_inclusion if true the match must be exactly included
@@ -71,22 +90,25 @@
 		ArrayList<Match> result = new ArrayList<>();
 		int i1 = 0;
 		int i2 = 0;
-		for (; i2 < sublist2.size() && i1 < list1.size(); ) {
+		for (; i2 < sublist2.size() && i1 < list1.size();) {
 			Match m = list1.get(i1);
 			Match subm = sublist2.get(i2);
 			if (m.getEnd() < subm.getStart()) {
 				i1++;
-			} else if (subm.getEnd() < m.getStart()) {
+			}
+			else if (subm.getEnd() < m.getStart()) {
 				i2++;
-			} else {
+			}
+			else {
 				if (strict_inclusion) {
 					if (m.getStart() <= subm.getStart() && subm.getEnd() <= m.getEnd()) {
 						result.add(subm);
 					}
-				} else {
+				}
+				else {
 					result.add(subm);
 				}
-
+				
 				i2++;
 			}
 		}
Index: tmp/org.txm.core/src/java/org/txm/objects/Project.java
===================================================================
--- tmp/org.txm.core/src/java/org/txm/objects/Project.java	(revision 3060)
+++ tmp/org.txm.core/src/java/org/txm/objects/Project.java	(revision 3061)
@@ -881,6 +881,10 @@
 					tmp.setTextContent(this.getTokenizerParameter("regElision", ""));
 					tokenizerElement.appendChild(tmp);
 					
+					for (EditionDefinition ed2 : this.getEditionDefinitions()) {
+						if ("default".equals(ed2.getName())) continue; // "default" is already declared
+						bp.addEditionDefinition(corpusElem, ed2.getName(), "html", this.getImportModuleName());
+					}
 					EditionDefinition ed = this.getEditionDefinition("default");
 					bp.setPageBreakElement(ed.getPageElement());
 					bp.setWordsPerPage(ed.getWordsPerPage());
@@ -888,7 +892,6 @@
 					bp.setTextualPlans(this.getTextualPlan("OutSideTextTagsAndKeepContent"), this.getTextualPlan("Note"), this.getTextualPlan("OutSideTextTags"), this.getTextualPlan("MileStones"));
 					bp.setWordElement(this.getTokenizerWordElement());
 					
-					
 					for (Text t : this.getTexts()) {
 						Element elementT = bp.addText(corpusElem, t.getName(), t.getSource());
 						for (Edition e : t.getEditions()) {
